
/// <reference path="~/sdk/web1/lib1/innovaphone.lib1.js" />
/// <reference path="~/sdk/web1/ui1.lib/innovaphone.ui1.lib.js" />
/// <reference path="~/sdk/web1/appwebsocket/innovaphone.appwebsocket.connection.js" />

var plugin = plugin || {};
plugin.innovaphone = plugin.innovaphone || {};
plugin.innovaphone.ManagerSDKProvisioning = innovaphone.ManagerSDKProvisioning || function (start, item, app) {
    this.createNode("div", null, null, "item-node");
    innovaphone.lib1.loadCss(item.uri + ".css");

    var colorSchemes = {
        dark: {
            "--innovaphone-sdkprovisioning-item": "#333333",
            "--innovaphone-sdkprovisioning-item-text": "#f2f5f6",
            "--innovaphone-sdkprovisioning-client-bg1": "#232323", // AppClient BG
            "--innovaphone-sdkprovisioning-client-bg2": "#161616", // AppClient Header-BG
            "--innovaphone-sdkprovisioning-bg1": "#282828", // background lv1
            "--innovaphone-sdkprovisioning-bg2": "#333333", // background lv2
            "--innovaphone-sdkprovisioning-bg3": "#474747", // background lv3
            "--innovaphone-sdkprovisioning-c1": "#efefef", // for bg1
            "--innovaphone-sdkprovisioning-c2": "#939393", // for bg2
            "--innovaphone-sdkprovisioning-highlight-bg": "#595959", // used as highlight-color
            "--innovaphone-sdkprovisioning-accent": "#239491",
            "--innovaphone-sdkprovisioning-input": "#191919",
            "--innovaphone-sdkprovisioning-input-text": "#f2f5f6",
            "--innovaphone-sdkprovisioning-button": "#191919",
            "--innovaphone-sdkprovisioning-button-text": "#f2f5f6",
            "--innovaphone-sdkprovisioning-button-bg": "#3D3D3D",
            "--innovaphone-sdkprovisioning-red": "#ef4d64",
            "--innovaphone-sdkprovisioning-green": "#7cb270",
        },
        light: {
            "--innovaphone-sdkprovisioning-item": "#e9eef1",
            "--innovaphone-sdkprovisioning-item-text": "#4a4a4a",
            "--innovaphone-sdkprovisioning-client-bg1": "#b7b7b7", // AppClient BG
            "--innovaphone-sdkprovisioning-client-bg2": "#999999", // AppClient Header-BG
            "--innovaphone-sdkprovisioning-bg1": "#cccccc", // background lv1
            "--innovaphone-sdkprovisioning-bg2": "#dddddd", // background lv2
            "--innovaphone-sdkprovisioning-bg3": "#f7f7f7", // background lv3
            "--innovaphone-sdkprovisioning-c1": "#444444", // for bg1
            "--innovaphone-sdkprovisioning-c2": "#777777", // for bg2
            "--innovaphone-sdkprovisioning-highlight-bg": "#eaeaea", // used as highlight-color
            "--innovaphone-sdkprovisioning-accent": "#239491",
            "--innovaphone-sdkprovisioning-input": "white",
            "--innovaphone-sdkprovisioning-input-text": "#4a4a49",
            "--innovaphone-sdkprovisioning-button": "white",
            "--innovaphone-sdkprovisioning-button-text": "#4a4a49",
            "--innovaphone-sdkprovisioning-button-bg": "#CCCCCC",
            "--innovaphone-sdkprovisioning-red": "#ef4d64",
            "--innovaphone-sdkprovisioning-green": "#7cb270",
        }
    };

    var svgIcons = {
        checkmark: "<path d=\"M6.67,17.5,0,10.81,1.62,9.18l5.05,5.06L18.38,2.5,20,4.13Z\"/>",
        close: "<path d=\"M7.5,10,1.68,4.18l2.5-2.5L10,7.5l5.82-5.82,2.5,2.5L12.5,10l5.82,5.82-2.5,2.5L10,12.5,4.18,18.32l-2.5-2.5Z\"/>"
    }

    var schemes = new innovaphone.ui1.CssVariables(colorSchemes, start.scheme);
    start.onschemechanged.attach(function () { schemes.activate(start.scheme) });

    var texts, add, sdkprovisioningList, templatesList, templatesListCn, profileApps, instance, sdkprovisioningURL, cont1, cont2;
    var pbxReplicator = null;
    var allowDelete = false;

    var body = this.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-body"));
    var panel = body.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-panel"));
    var src = new app.Src(pbx);
    var sdkprovisioning = [];
    var sdkprovisioningWS = null;
    var typeText = ["sdkprovisioning"];
    var typeUrl = ["/innovaphone-sdkprovisioning"];
    var copyPwd = null;
    var sdkprovisioningConfig = null;

    var managerApi = start.consumeApi("com.innovaphone.manager");

    innovaphone.lib1.loadObjectScript(item.uri + "Texts", function () {
        texts = new innovaphone.lib1.Languages(innovaphone.ManagerSDKProvisioningTexts, start.lang);
        instance = new innovaphone.appwebsocket.Connection("ws" + item.uri.slice(4), "-", null, app.domain, instanceConnected, instanceMessage, null, null, instanceLogin);
    });

    function instanceLogin(app, challenge) {
        var src = new managerApi.Src(getlogin);
        src.send({ mt: "GetInstanceLogin", path: item.uri.slice(item.uri.indexOf("/", 8) + 1, item.uri.lastIndexOf("/")), app: app, challenge: challenge }, item.ap);

        function getlogin(obj) {
            instance.login(obj.msg);
        }
    }

    function instanceConnected() {
        console.log("Instance Connected");
        read();
    }

    function instanceMessage(msg) {
    }

    function sdkprovisioningLogin(app, challenge) {
        var srcus = new managerApi.Src(getlogin);
        srcus.send({ mt: "GetInstanceLogin", path: sdkprovisioningURL.slice(sdkprovisioningURL.indexOf("/", 8) + 1, sdkprovisioningURL.lastIndexOf("/")), app: app, challenge: challenge }, item.ap);
        function getlogin(obj) {
            console.log("Recv: " + JSON.stringify(obj.msg));
            sdkprovisioningWS.login(obj.msg);
            srcus.close();
        }
    }

    function sdkprovisioningConnected() { }

    function sdkprovisioningMessage(msg) {
        if (msg.mt == "ReadConfigResult") {
            allowDelete = msg.ConfigItems.allowDelete;
            pbxReplicator = msg.ConfigItems.pbxName;
        }
    }

    function read() {
        panel.clear();
        var header = panel.add(new innovaphone.ui1.Div("display:flex; flex-direction:row;", null, "innovaphone-sdkprovisioning-obj")).addEvent("click", onadd).testId("innovaphone-sdkprovisioning-add");
        add = header.add(new innovaphone.ui1.SvgInline("position:relative; left:10px; width:20px; top:10px; height:20px; fill:var(--innovaphone-sdkprovisioning-item-text); cursor:pointer", "0 0 20 20", "<path d=\'M8.24,8.24V0h3.52V8.24H20v3.52H11.76V20H8.24V11.76H0V8.24Z'/>"));
        header.add(new innovaphone.ui1.Div("padding: 5px 10px;", null, "innovaphone-sdkprovisioning-label2")).addTranslation(texts, "addapp");
        sdkprovisioningList = panel.add(new innovaphone.ui1.Scrolling("position:relative; flex: 1 1 0;", -1, 0));
        sdkprovisioning = [];
        profileApps = [];
        copyPwd = null;
        sdkprovisioningURL = item.uri.replace(item.uri.split("/").splice(-1), "");

        sdkprovisioningWS = new innovaphone.appwebsocket.Connection(sdkprovisioningURL.replace("http", "ws"), "-", null, app.domain, sdkprovisioningConnected, sdkprovisioningMessage, null, null, sdkprovisioningLogin);

        initSDKProvisioning();
        src.send({ mt: "GetAppObjects", api: "PbxAdminApi", uri: item.uri.slice(0, item.uri.lastIndexOf("/")) });
    }

    function onadd() {
        panel.clear();
        var header = panel.add(new innovaphone.ui1.Div("position:relative; box-sizing:border-box; padding:10px; width:100%; color: var(--innovaphone-sdkprovisioning-c2); font-size: 18px;")).addTranslation(texts, "addapp");
        var content = panel.add(new innovaphone.ui1.Scrolling("position:relative; width:100%; margin-top: 5px;flex: 1 1 0;", -1, 0));
        var selection = content.add(new innovaphone.ui1.Div("position:relative; width:100%; display:flex; flex-wrap:wrap; align-content:flex-start"));
        var select = content.add(new innovaphone.ui1.Div("position:relative; width:100%; display:flex; flex-wrap:wrap; align-content:flex-start"));
        addSelect(select, 0);
        var footer = panel.add(new innovaphone.ui1.Div("position: relative; margin-top: auto; display: flex; flex-direction: row;"));
        footer.add(new innovaphone.ui1.Div("margin-left:auto; margin-top:auto;", null, "innovaphone-sdkprovisioning-button")).addTranslation(texts, "cancel").addEvent("click", oncancel);

        function oncancel() { read(); }

        function addSelect(select, typeIndex, appid, iconpath) {
            if (!appid) appid = typeText[typeIndex];
            if (!iconpath) iconpath = typeUrl[typeIndex] + ".png";
            var appselect = select.add(new innovaphone.ui1.Div("width:170px;height:50px;", null, "innovaphone-sdkprovisioning-choice")).addEvent("click", function () {
                select.clear();
                panel.container.removeChild(footer.container);
                selection.add(new innovaphone.ui1.Div("text-align: left; background-color: transparent; font-size: 16px;", null, "innovaphone-sdkprovisioning-selection")).addTranslation(texts, appid);
                new EditSDKProvisioning({ type: typeIndex }, content);
            }).testId("innovaphone-sdkprovisioning-" + appid);
            var appicon = appselect.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-appicon"));
            appicon.container.style.backgroundImage = "url(" + item.uri.slice(0, item.uri.lastIndexOf("/")) + iconpath + ")";
            appicon.container.style.backgroundSize = "cover";
            appselect.add(new innovaphone.ui1.Div("position:absolute; left:50px; top:5px; height:30px;", null, "innovaphone-sdkprovisioning-label2")).addTranslation(texts, appid);

        }
    }

    function pbx(msg) {
        if (msg.mt == "GetAppObjectsResult") {
            for (var i = 0; i < msg.objects.length; i++) {
                sdkprovisioningList.add(new SDKProvisioning(msg.objects[i]));
            }
            templatesList = [];
            templatesListCn = [];
            src.send({ mt: "GetConfigObjects", api: "PbxAdminApi" });
        }
        else if (msg.mt == "GetConfigObjectsResult") {
            for (var i = 0; i < msg.objects.length; i++) {
                templatesListCn[templatesListCn.length] = msg.objects[i].cn;
            }
            if (templatesListCn.length > 0) src.send({ mt: "GetObject", api: "PbxAdminApi", cn: templatesListCn[0] });
        }
        else if (msg.mt == "GetObjectResult") {
            var tmpl = new Object();
            tmpl.apps = msg.apps ? msg.apps.split(",") : [];
            tmpl.cn = msg.cn;
            tmpl.guid = msg.guid;
            templatesList[templatesList.length] = tmpl;
            templatesListCn.splice(templatesListCn.indexOf(msg.cn), 1);
            if (templatesListCn.length > 0) src.send({ mt: "GetObject", api: "PbxAdminApi", cn: templatesListCn[0] });
        }
    }

    function SDKProvisioning(obj) {
        if (obj.type == undefined) {
            obj.type = 0;
            if (obj.pseudo != "sdkprovisioning") {
                for (var i = 0; i < typeUrl.length; i++) {
                    if (obj.url.slice(obj.url.lastIndexOf("/")) == typeUrl[i]) {
                        obj.type = i;
                        if (i == 2) profileApps[profileApps.length] = obj.sip;
                        break;
                    }
                }
            }
        }

        this.createNode("div", null, null, "innovaphone-sdkprovisioning-obj").testId("innovaphone-sdkprovisioning-obj-" + obj.sip);
        this.addEvent("click", onedit);
        this.obj = obj;
        var appName = this.add(new innovaphone.ui1.Div("width:100px; font-size:15px; color:var(--innovaphone-sdkprovisioning-item-text);", null, "innovaphone-sdkprovisioning-label2")).addTranslation(texts, typeText[obj.type]);
        var header = this.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-header"));
        var title = header.add(new Text("title", obj.title, 120, 100));
        var sip = header.add(new Text("sip", obj.sip, 120));
        var url = header.add(new Text("url", obj.url.slice(obj.url.lastIndexOf("/")), 220));

        var src = new app.Src(result);
        src.send({ mt: "GetAppLogin", api: "PbxAdminApi", challenge: "1234", app: obj.sip });
        function result(msg) {
            var isrc = new instance.Src(check);
            isrc.send({ mt: "AppCheckLogin", app: msg.app, challenge: "1234", digest: msg.digest });
            function check(msg) {
                if (msg.ok) {
                    if (!copyPwd) copyPwd = obj.sip;
                    header.add(new innovaphone.ui1.SvgInline("position:relative; width:20px; height:20px; margin:5px; fill:var(--innovaphone-sdkprovisioning-green)", "0 0 20 20", "<path d=\'M6.67,17.5,0,10.81,1.62,9.18l5.05,5.06L18.38,2.5,20,4.13Z'/>"));
                }
            }
        }
        function onedit() {
            panel.clear();
            var header = panel.add(new innovaphone.ui1.Div("position:relative; box-sizing:border-box; padding:10px; width:100%; color: var(--innovaphone-sdkprovisioning-c2); font-size: 18px;")).addTranslation(texts, "editapp");
            var content = panel.add(new innovaphone.ui1.Scrolling("position:relative; width:100%; margin-top: 5px;flex: 1 1 0;", -1, 0));
            new EditSDKProvisioning(obj, content);
        }
    }
    SDKProvisioning.prototype = innovaphone.ui1.nodePrototype;

    function EditSDKProvisioning(obj, content) {
        var popup = null;
        var footer = panel.add(new innovaphone.ui1.Div("position: relative; margin-top: auto; display: flex; flex-direction: row;"));
        if (obj.guid) footer.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-button")).addTranslation(texts, "del").addEvent("click", ondel).testId("innovaphone-sdkprovisioning-del");
        footer.add(new innovaphone.ui1.Div("flex:1 1 0;", null, null));
        footer.add(new innovaphone.ui1.Div(null, null, "innovaphone-sdkprovisioning-button")).addTranslation(texts, "cancel").addEvent("click", oncancel);
        footer.add(new innovaphone.ui1.Div("background-color:var(--green);", null, "innovaphone-sdkprovisioning-button")).addTranslation(texts, "ok").addEvent("click", onok).testId("innovaphone-sdkprovisioning-ok");

        var general = content.add(new innovaphone.ui1.Div("position:relative; display:flex; flex-wrap: wrap;"));
        var title = general.add(new ConfigText("title", obj.title, 150)).testId("innovaphone-sdkprovisioning-cn");
        var sip = general.add(new ConfigText("sip", obj.sip, 150)).testId("innovaphone-sdkprovisioning-sip");
        var templts = content.add(new innovaphone.ui1.Div("position:relative; display:flex; flex-wrap: wrap;"));
        var tmp = [];
        var tmpSelected = [];
        for (var i = 0; i < templatesList.length; i++) {
            tmp[i] = templts.add(new ConfigTemplate(obj.sip, templatesList[i])).testId("innovaphone-sdkprovisioning-temp-" + templatesList[i].cn);
        }

        function ondel() {
            popup = body.add(new Popup(this, texts, onDelete));
        }

        this.closePopup = function () {
            if (popup) body.rem(popup);
            popup = null;
        };

        this.onDelete = function () { onDelete(); }

        function onDelete() {
            var src = new app.Src(result);
            src.send({ mt: "DeleteObject", api: "PbxAdminApi", guid: obj.guid });

            function result() {
                src.close();
                read();
            }
        }

        function onok() {
            var src = new app.Src(result);
            var pwd = innovaphone.Manager.randomPwd(16);
            tmpSelected = [];
            for (var i = 0; i < tmp.length; i++) {
                if (tmp[i].getValue()) tmpSelected[tmpSelected.length] = tmp[i].getLabel();
            }
            if (obj.type == 0) {
                src.send({ mt: "UpdateObject", api: "PbxAdminApi", hide: true, critical: true, copyPwd: copyPwd, cn: title.getValue(), guid: obj.guid, h323: sip.getValue(), pwd: pwd, apps: "devices,devices-api", pseudo: { type: "app", app: { url: item.httpsUri.slice(0, item.httpsUri.lastIndexOf("/")) + typeUrl[obj.type], websocket: "on", services: "on" } } });
            }
            else {
                src.send({ mt: "UpdateObject", api: "PbxAdminApi", hide: true, critical: true, copyPwd: copyPwd, cn: title.getValue(), guid: obj.guid, h323: sip.getValue(), pwd: pwd, apps: "devices,devices-api", pseudo: { type: "app", app: { url: item.httpsUri.slice(0, item.httpsUri.lastIndexOf("/")) + typeUrl[obj.type], websocket: "on", services: "on" } } });
            }

            function result(msg) {
                if (!msg.error) {
                    if (msg.mt == "UpdateObjectResult") {
                        var sent = false;
                        if (tmp.length > 0) {
                            for (var i = 0; i < templatesList.length; i++) {
                                if (templatesList[i].cn == tmp[0].getLabel()) {
                                    var selected = tmp[0].getValue();
                                    tmp.splice(0, 1);
                                    if (selected && templatesList[i].apps.indexOf(sip.getValue()) < 0) {
                                        templatesList[i].apps[templatesList[i].apps.length] = sip.getValue();
                                        src.send({ mt: "UpdateObject", api: "PbxAdminApi", cn: templatesList[i].cn, guid: templatesList[i].guid, apps: templatesList[i].apps.join(",") });
                                        sent = true;
                                        break;
                                    }
                                    else if (!selected && templatesList[i].apps.indexOf(sip.getValue()) >= 0) {
                                        templatesList[i].apps.splice(templatesList[i].apps.indexOf(sip.getValue()), 1);
                                        src.send({ mt: "UpdateObject", api: "PbxAdminApi", cn: templatesList[i].cn, guid: templatesList[i].guid, apps: templatesList[i].apps.join(",") });
                                        sent = true;
                                        break;
                                    }
                                }
                            }
                        }
                        if (!sent) setPwd();
                    }
                    else if (msg.mt == "GetObjectResult") {
                    }

                    function setPwd() {
                        src.close();
                        if (copyPwd) {
                            read();
                        }
                        else {
                            src = new managerApi.Src(result);
                            src.send({ mt: "SetInstancePassword", path: item.uri.slice(item.uri.indexOf("/", 8) + 1, item.uri.lastIndexOf("/")), pwd: pwd }, item.ap);
                            function result() {
                                src.close();
                                read();
                            }
                        }
                    }
                }
                else {
                    title.setError(true);
                }
            }
        }

        function oncancel() {
            read();
        }
    }
    EditSDKProvisioning.prototype = innovaphone.ui1.nodePrototype;

    function Text(label, text, width, lwidth) {
        this.createNode("div", "position:relative; display:flex;");
        this.add(new innovaphone.ui1.Div(lwidth ? "width:" + lwidth + "px" : null, null, "innovaphone-sdkprovisioning-label")).addTranslation(texts, label);
        var text = this.add(new innovaphone.ui1.Div("width:" + width + "px", text, "innovaphone-sdkprovisioning-value"));
        this.set = function (t) { text.container.innerText = t; };
    }
    Text.prototype = innovaphone.ui1.nodePrototype;

    function ConfigText(label, text, width) {
        this.createNode("div", "position:relative; display:flex; margin-right: 5px;");
        var label = this.add(new innovaphone.ui1.Div("padding: 3px 5px;", null, "innovaphone-sdkprovisioning-label")).addTranslation(texts, label);
        var inputDiv = this.add(new innovaphone.ui1.Div("position:relative; width:" + width + "px"));
        var input = inputDiv.add(new innovaphone.ui1.Input(null, text, null, 100, null, "innovaphone-sdkprovisioning-input"));

        this.getValue = function () { return input.getValue(); };
        this.setValue = function (value) { input.setValue(value); };
        this.testId = function (id) { input.testId(id); return this; };
        this.setError = function (on) { input.container.style.border = (on ? "1px solid red" : null); };
    }
    ConfigText.prototype = innovaphone.ui1.nodePrototype;

    function ConfigTemplate(sip, template) {
        this.createNode("div", "position:relative; display:flex; margin-right: 5px;");
        var checkbox = this.add(new innovaphone.ui1.Checkbox("position:relative; margin: 7px 0px 7px 15px; width: 20px; height:20px; background-color:var(--innovaphone-sdkprovisioning-green);", false, null, "var(--innovaphone-sdkprovisioning-green)", "white", "var(--innovaphone-sdkprovisioning-c1)"));
        var label = this.add(new innovaphone.ui1.Div("padding: 3px 5px 3px 0px;", template.cn, "innovaphone-sdkprovisioning-label"));
        if (template.apps.indexOf(sip) >= 0) checkbox.setValue(true);

        this.getValue = function () { return checkbox.getValue(); };
        this.setValue = function (value) { checkbox.setValue(value); };
        this.getLabel = function () { return label.container.innerText; };
        this.testId = function (id) { checkbox.testId(id); return this; };
        this.setError = function (on) { label.container.style.border = (on ? "1px solid red" : null); };
    }
    ConfigTemplate.prototype = innovaphone.ui1.nodePrototype;

    function initSDKProvisioning() { }

    function cleanCont(cont) {
        while (cont.container.childNodes.length > 1) { cont.container.removeChild(cont.container.childNodes[cont.container.childNodes.length - 1]); }
    }

    function Dropdown(options) {
        var dropdown = this;
        dropdown.createNode("select");

        function addOption(text) {
            var option = dropdown.add(new innovaphone.ui1.Node("option", "background-color: var(--forms); border: none; flex: 1 1 auto; overflow: hidden;", text));
            option.container.value = text;
        }

        this.getSelected = function () { return dropdown.container.value; }
        this.setSelected = function (option) { dropdown.container.value = option; }
        options.forEach(addOption);
        return dropdown;
    }
    Dropdown.prototype = innovaphone.ui1.nodePrototype;

}
plugin.innovaphone.ManagerSDKProvisioning.prototype = innovaphone.ui1.nodePrototype;

function Popup(main, str, onOK) {
    var that = this,
        popup = null,
        headline = null,
        infoTxt = null,
        btnCont = null,
        cancelBtn = null,
        confirmBtn = null;

    function init() {
        that.createNode("div", null, null, "overlay-sdkprovisioning");
        popup = that.add(new innovaphone.ui1.Div(null, null, "popup-sdkprovisioning"));
        headline = popup.add(new innovaphone.ui1.Node("h1")).addTranslation(str, "reallyDel");
        infoTxt = popup.add(new innovaphone.ui1.Div(null, null, "info-text-sdkprovisioning")).addTranslation(str, "infoTxt");
        btnCont = popup.add(new innovaphone.ui1.Div(null, null, "btn-cont-sdkprovisioning"));
        cancelBtn = btnCont.add(new innovaphone.ui1.Node("button", null, null, "button-row-sdkprovisioning")).addTranslation(str, "cancel");
        cancelBtn.addEvent("click", function () {
            str.clear(that);
            that.container.parentNode.removeChild(that.container);
        });
        confirmBtn = btnCont.add(new innovaphone.ui1.Node("button", null, null, "button-row-sdkprovisioning button-red-sdkprovisioning")).addTranslation(str, "del").testId("innovaphone-sdkprovisioning-popup-del");
        confirmBtn.addEvent("click", function () {
            str.clear(that);
            that.container.parentNode.removeChild(that.container);
            onOK();
        });
    };

    init();
}
Popup.prototype = innovaphone.ui1.nodePrototype;
